set camera "gige-dma-full-lx100_3-4Gbit"

if { $camera == "gige-dma-full-lx75_3" } {
   set device "xc6slx75"
   set package "csg484"
   set speed "-3"
} elseif { $camera == "gige-dma-full-lx100_3-4Gbit" } {
   set device "xc6slx100"
   set package "csg484"
   set speed "-3"
}

proc generate_xst_file {} {

   global device
   global package
   global speed

   if { [catch {
      set fh [open "CustomModule.xst" w ]
      set fh1 [open "../../syn/xst_set.txt" r ]
      set fh2 [open "../../syn/xst_run_open_camera.txt" r ]
      puts $fh "set"
      puts $fh [read $fh1]
      puts $fh "run"
      puts $fh "-uc ../src_open_camera/CustomModule.xcf"
      puts $fh "-ifn ../src_open_camera/CustomModule.prj"
      puts $fh "-ofn CustomModule"
      puts $fh "-p ${device}${speed}-${package}"
      puts $fh "-top CustomModule"
      puts $fh [read $fh2]
      close $fh
      close $fh1
      close $fh2
   } res ] } {
      return -code error $res
   } else {
      return 1
   }
}

#--------------Start Command----------------

if { [ file isdirectory ../$camera/xst_open_camera ] } {
   file delete -force ../$camera/xst_open_camera
}
file mkdir ../$camera/xst_open_camera
cd ../$camera/xst_open_camera
file mkdir xst
if { [catch { generate_xst_file } res] } {
   puts "ERROR: Couldn't generate xst-file (CustomModule.xst) \n"
}
puts "Synthesis - XST running..\n"
exec xst -ifn "CustomModule.xst" -ofn "CustomModule.syn" | tee -a "CustomModule.xst_log"
puts "Synthesis - XST completed\n"
if { [ file isdirectory ../../ise ] } {
   cd ../../ise
} else {
   cd ../../tcl
}