#!/bin/bash
PAR_DIR=../par
NGD_DIR=../ngd
args=("$@")
if [ $# -eq 1 ]; then
   echo "*****************************************"
   echo "trce"
   echo "Number of arguments passed: $#"
   PRO="${args[0]}"
   echo "starting trce for project $PRO"
   echo "see logfile $PRO.trce_log"
   echo "*****************************************"
else
   echo "*****************************************"
   echo Number of arguments passed: $#
   echo
   echo "usage: ./trce.sh <project>"
   echo "*****************************************"
   exit 1;
fi
   if [ -d tim ]; then
   rm -rf tim
   fi
   mkdir tim
   cd tim

   if [ -r $PAR_DIR/$PRO.ncd ]; then
      echo "Found ncd file $PRO.ncd"
      else
      echo "No ncd file $PRO.ncd"
      exit 1;
   fi
   if [ -r $NGD_DIR/$PRO.pcf ]; then
      echo "Found pcf file $PRO.pcf"
      else
      echo "No pcf file $PRO.pcf"
      exit 1;
   fi
   date > $PRO.trce_log
   trce -intstyle xflow -v 3 -u 5 -n 3 -fastpaths -o $PRO.v3.twr $PAR_DIR/$PRO.ncd $NGD_DIR/$PRO.pcf | tee -a $PRO.trce_log
   trce -e 15 -u 50 -n 5 -tsi $PRO.tsi -timegroups -o $PRO.e15.twr $PAR_DIR/$PRO.ncd $NGD_DIR/$PRO.pcf | tee -a $PRO.trce_log
   
   date >> $PRO.trce_log
   cd ..
   exit;
   
# $ trce.exe
# Release 12.4 - Trace  (nt)
# Copyright (c) 1995-2010 Xilinx, Inc.  All rights reserved.
# Usage: trce.exe [-e|-v [<limit:0,2000000000>]] [-l <limit:0,2000000000>] [-n
# [<limit:0,2000000000>]] [-u [<limit:0,2000000000>]] [-a] [-s <speed>] [-o
# <report[.twr]>] [-stamp <stampfile>] [-tsi <tsifile[.tsi]>] [-xml
# <report[.twx]>] [-nodatasheet] [-timegroups] [-fastpaths] [-intstyle
# ise|xflow|silent] [-ise <projectfile>] [-filter <filter_file[.filter]>]
# <design[.ncd]> [<constraint[.pcf]>]

# <design[.ncd]>     ... Xilinx physical design file (no default)
# <constraint[.pcf]> ... optional physical constraint file (default design.pcf)
# -o <report[.twr]>  ... report output file (default design.twr)
# -xml <report[.twx]> ... XML report output file (default design.twx)
# -e [<limit>]       ... produce detailed error report for timing constraints
                       # optionally limited to the number of items specified by
                       # <limit>
# -v [<limit>]       ... produce verbose timing report for timing constraints
                       # optionally limited to the number of items specified by
                       # <limit>
# -l [<limit>]       ... produce timing report for timing constraints
                       # optionally limited to the number of items specified by
                       # <limit>
# -n [<limit>]       ... report paths per endpoint (default is per constraint)
                       # optionally limited to the number of endpoints specified
                       # by <limit>. This switch requries -v or -e
# -s <speed>         ... run analysis with the speed grade specified by <speed>.
                       # This switch requries -v or -e
# -a                 ... perform advanced design analysis in the absence
                       # of a physical constraint file. This switch requires
                       # -v or -e
# -u [<limit>]       ... report unconstrained paths optionally limited to the
                       # number of items specified by <limit>. This switch
                       # requries -v or -e
# -f <filename>      ... use the file specified by <filename> as command input
# -stamp <stampfile> ... optionally generate STAMP model and data files. This
                       # switch requires -v or -e
# -tsi <tsifile[.tsi]> ... produce timing specification interaction report. This
                         # switch requries -v or -e
# -nodatasheet       ... do not create the datasheet section of the report. This
                       # switch requires -v or -e
# -timegroups        ... create the table of timegroups section of the report
                       # This switch requires -v or -e
# -fastpaths         ... report fastest paths/verbose hold paths. This switch
                       # requires -v or -e
# -filter <filter_file[.filter] ... Message Filter file name (for example
                       # "filter.filter"). If specified, the contents of this
                       # file will be used to filter messages from this
                       # application. The filter file can be created using
                       # Xreport. This switch requires -v or -e
# -intstyle <style>  ... use the specified style: ise, xflow, or silent
# -ise <projectfile> ... use the ISE project file specified by <projectfile>
# TRCE: Creates a Timing Report file (TWR) derived from static timing
# analysis of the Physical Design file (NCD). The analysis is typically
# based on constraints included in the optional Physical Constraints file (PCF).



